//Serena Bailey ITDEV 110 FINAL EXAM
package bailey_finalexam;

import java.util.ArrayList;
import java.util.Iterator;

   
public class Model {

    //variables being called to.
    private int[] newAssignments;
    private int[] discussions;
    private int[] exams;
    private int individualproject;
    private int newIndividual;
    private int totalGrade;
   
    
    public void addTrackerRecord(ArrayList<GradeBookTracker> card,GradeBookTracker tc)
    {
      //here is where we will display both the records on file as well as entered records.  
      card.add(tc);         
      displayAll(card);   
      
    }

    public void searchByLastName(ArrayList<GradeBookTracker> card, String searcher)
    {
     //where a user will search for by a last name. This is where it is being searched for and found for display purposes.
        for (GradeBookTracker tc : card) {
            if (tc.lname.equals(searcher)) {
                System.out.println("RECORD FOUND: ");
                System.out.println(tc.toString());

            }
        }
        
        
    }
    public void searchByID(ArrayList<GradeBookTracker> card, String searcher)
    {
     //where a user will search for by an ID. This is where it is being searched for and found for display purposes.   
        for (GradeBookTracker tc : card) {
            if (tc.ID.equals(searcher)) {
                  System.out.println("RECORD FOUND: ");
                  System.out.println(tc.toString());

            }
        }
        
        
    }
    public void displayAll(ArrayList<GradeBookTracker> card)
    { 
     //here is where we are going to display all the tracker cards we have on file.       
        for (GradeBookTracker tc : card) {
            System.out.println(tc.toString());

        }
    }
    
    public void editGradeBookTracker(ArrayList<GradeBookTracker> card, String name, String ID, int[] assignmentsArray, int[] discussionsArray, int[] examsArray, int newIndividual, int totalAssignments, int totalDiscussions, int totalExams, int choice) 
    {
        //here is the menu for making any edits to the entries. 
        int index = 0;
        for (GradeBookTracker tc : card) {
            if (tc.lname.equals(name)) 
            {
                switch (choice) {
                    case 1:
                        tc.ID = ID;
                        break;
                    case 2:
                        tc.assignmentsArray = newAssignments;
                        break;
                    case 3:
                        tc.discussionsArray = discussions;
                        break;
                    case 4:
                        tc.examsArray = exams;
                        break;
                    case 5:
                        tc.individualProject = newIndividual;
                        break;
                    default:
                        break;
                }
                card.set(index, tc);     
            }
            index++;
        }  
        displayAll(card);
        
        
    }

}

