//Serena Bailey ITDEV 110 FINAL EXAM
package bailey_finalexam;

import java.util.ArrayList;
import java.util.Scanner;

public class UserInterface {
    //calling to our various classes universally through the class and our variables. Also adding a scanner keyboard so we can get the users input throughout the class.
   Model model = new Model(); 
   
   Scanner keyboard = new Scanner(System.in); 
   
   int option;
   int choice;
   String name;
   String ID;
   String addFName;
   String addLName;
   String addID;
   int addIndividualProject;
   int assignmentToChange;
   int newAssignment;
   int discussionToChange;
   int newDiscussion;
   int examToChange;
   int newExam;
   int individualToChange;
   int newIndividual;
   int assignments; 
   int discussions; 
   int exams;
   int[] assignmentsArray = {0,0,0,0,0,0,0,0,0,0};
   int[] discussionsArray = {0,0,0,0,0,0,0,0,0,0};
   int[] examsArray = {0,0};
   String[] assignmentArray;
   String[] discussionArray;
   String[] examArray;
   int individualProject;
   int numAssignments;
   int numDiscussions; 
   int numExams;
   int numIndividualProject;
   int totalAssignments;
   int totalDiscussions;
   int totalExams;
   int letterGrade;
   int totalGrade = 0;
   
   public int getUserInput()
   {
       //where the user will decide what option they're going to take.
       System.out.println();
       System.out.println("1(ADD) \n2(SEARCH) \n3(DISPLAY) \n4(EDIT) \n5(GRADE) \n0(EXIT)\n");
       System.out.println();
       option = keyboard.nextInt();
       return option;
   }
   
   public int getUserInputForSearch()
   {
       //where we get the user input if they wish to do a search.
       keyboard.nextLine();
 
       System.out.println("Press 1 TO SEARCH BY LAST NAME");
       System.out.println("Press 2 TO SEARCH BY STUDENT ID\n");
       choice = keyboard.nextInt();
       
       return choice;
   }
   
   public void getUserInputForAdd(ArrayList<GradeBookTracker> card)
   {
       //This is where we are going to get all of the users information entered.
       Scanner addScan = new Scanner(System.in);

       System.out.println("ENTER FIRST NAME TO ADD: ");
       addFName = addScan.nextLine();
       
       
       System.out.println("ENTER LAST NAME TO ADD: ");
       addLName = addScan.nextLine();
 
       System.out.println("ENTER STUDENT ID TO ADD: ");
       addID = addScan.nextLine();
       
       System.out.println("ENTER AMOUNT OF ASSIGNMENTS TO ADD (UP TO 10 - MAX 50PTS EA.): ");
       
       assignmentsArray = getAssignments();
       
       System.out.println("ENTER AMOUNT OF DISCUSSIONS TO ADD (UP TO 10 - MAX 10PTS EA.): ");
       
       discussionsArray = getDiscussions();
       
       System.out.println("ENTER AMOUNT OF EXAMS TO ADD (UP TO 2 - MAX 150PTS EA.): ");
       
       examsArray = getExams();
       
       System.out.println("AMOUNT OF INDIVIDUAL PROJECT SCORE TO ADD (UP TO MAX 100PTS): ");
       addIndividualProject = keyboard.nextInt();
       if (addIndividualProject >= 101)
       {
           System.out.println("You have entered a number outside of the Parameter. Please re-enter.");
           addIndividualProject = keyboard.nextInt();
       }
       else{
           
       }

       //here is where we are passing the information gathered to the model class.
       GradeBookTracker tc = new GradeBookTracker(addFName, addLName, addID, assignmentsArray, discussionsArray, examsArray, addIndividualProject, totalAssignments, totalDiscussions, totalExams, totalGrade);
       model.addTrackerRecord(card, tc); 
   }
   public int[] getAssignments()
   {
       //where we get the assignments entered by the user.
       keyboard.nextLine();
       numAssignments = keyboard.nextInt();
       addAssignments(numAssignments);
       return assignmentsArray;
   }
   
    public int[] getDiscussions()
   {
       //where we get the discussions entered by the user.
       keyboard.nextLine();
       numDiscussions = keyboard.nextInt();
       addDiscussions(numDiscussions);
       return discussionsArray;
   }
      
    public int[] getExams()
   {
       //where we get the exams entered by the user.
       keyboard.nextLine();
       numExams = keyboard.nextInt();
       addExams(numExams);
       return examsArray;
   }
         
   public String getName()
   {   
       //where we're getting the users entry of a last name to do a search.
       keyboard.nextLine();
       System.out.println("\n");
       System.out.println("ENTER LAST NAME OF STUDENT YOU'D LIKE TO FIND:\n");
       name = keyboard.nextLine();
       return name;
   } 
   
   public String getID()
   {
       //where we're getting the users entry of the ID number to do a search.
       keyboard.nextLine();
       System.out.println("\n");
       System.out.println("ENTER STUDENT ID YOU'D LIKE TO FIND:\n");
       ID = keyboard.nextLine();
       System.out.println("In UI, getting ID" + ID);
       return ID;
   }
    
    public void addAssignments(int numAssignments)
    {
     //here is where we are getting the assignments and placing them into the array for storage.   
        for (int i = 0; i < assignmentsArray.length; i++)
        {
            int assignmentArray = assignmentsArray[i];

        }
        
        keyboard.nextLine();
        System.out.println("\n");
       
        for (int i = 0; i < numAssignments; i++)
        {
            //in order to ensure that a running total for all users entered isn't established, we reset the value to 0 for every time an add is made.
            totalAssignments = 0;
            System.out.println("Enter Assignments " + (i + 1) + ": ");
            assignmentsArray[i] = keyboard.nextInt();
            totalAssignments = totalAssignments + assignmentsArray[i];
            
            if (numAssignments >= 51)
            {
                System.out.println("You have entered an invalid choice. Please re-enter.");
                getAssignments();
            }
            else{
                
            }
        } 
   
    }
    
    public void addDiscussions(int numDiscussions)
    {
     //here is where we are getting the discussions numbers to place into the array for storage.   
        for (int i = 0; i < discussionsArray.length; i++)
        {
            int discussionArray = discussionsArray[i];
        }
        
        keyboard.nextLine();
        System.out.println("\n");
       
        for (int i = 0; i < numDiscussions; i++)
        {
            //in order to ensure that a running total for all users entered isn't established, we reset the value to 0 for every time an add is made.
            totalDiscussions = 0;
            System.out.println("Enter Discussions " + (i + 1) + ": ");
            discussionsArray[i] = keyboard.nextInt();
            totalDiscussions = totalDiscussions + discussionsArray[i];
        } 
   
    }
        
    public void addExams(int numExams)
    {
     //where we're getting the users exams entries to be stored into the array.   
        for (int i = 0; i < examsArray.length; i++)
        {
            int examArray = examsArray[i];
        }
        
        keyboard.nextLine();
        System.out.println("\n");
       
        for (int i = 0; i < numExams; i++)
        {
            //in order to ensure that a running total for all users entered isn't established, we reset the value to 0 for every time an add is made.
            totalExams = 0;
            System.out.println("Enter Exams " + (i + 1) + ": ");
            examsArray[i] = keyboard.nextInt();
            totalExams = totalExams + examsArray[i];
        } 
   
    }
    
     
    public int getLetterGrade()
    {
       //this is where we will ask for the total score to figure out a letter grade based on the number.
       keyboard.nextLine();
       System.out.println("\n");
       System.out.println("ENTER THE TOTAL SCORE TO FIND OUT THE GRADE:\n");
       letterGrade = keyboard.nextInt();
       return letterGrade;
    }
    
    public void letterGrade()
    {
       //here is where we are figuring out based on the amount of points what grade it coincides with. 
        if (letterGrade >= 950)
        {
            System.out.println(" \tThis Students Grade is a A");
        }
        else if (letterGrade >= 900)
        {
            System.out.println(" \tThis Students Grade is a A-");
        }
        else if (letterGrade >= 850)
        {
            System.out.println(" \tThis Students Grade is a B+");
        }
        else if (letterGrade >= 800)
        {
            System.out.println(" \tThis Students Grade is a B");
        }
        else if (letterGrade >= 750)
        {
            System.out.println(" \tThis Students Grade is a B-");
        }
        else if (letterGrade >= 700)
        {
            System.out.println(" \tThis Students Grade is a C");
        }
        else if (letterGrade >= 650)
        {
            System.out.println(" \tThis Students Grade is a C-");
        }
        else if (letterGrade >= 600)
        {
            System.out.println(" \tThis Students Grade is a D+");
        }
        else if (letterGrade >= 550)
        {
            System.out.println(" \tThis Students Grade is a D");
        }
        else if (letterGrade >= 500)
        {
            System.out.println(" \tThis Students Grade is a D-");
        }
        else
        {
            System.out.println(" \tThis Students Grade is a F");
        }

    }
    
   public String getNameToEdit()
   {   
       //here is where we are getting the students last name to edit it.
       keyboard.nextLine();
       System.out.println("\n");
       System.out.println("ENTER LAST NAME OF STUDENT YOU'D LIKE TO EDIT:\n");
       name = keyboard.nextLine();
       return name;
   } 

    
    public void getUserInputForEdit(ArrayList<GradeBookTracker> card, String name)
    {   
        //here is the full edit menu that the user will see to make a choice and edit accordingly. A user can change the value of an array item, but it will change any duplicate ones in the array as well.
        System.out.println("1 Edit Student ID. ");
        System.out.println("2 Edit Assignments by Student ID. ");
        System.out.println("3 Edit Discussions by Student ID. ");
        System.out.println("4 Edit Exams by Student ID. ");
        System.out.println("5 Edit Individual Project by Student ID. ");
        choice = keyboard.nextInt();
        keyboard.nextLine();
        switch (choice) {
           case 1:
               System.out.println("ENTER THE NEW STUDENT ID:\n");
               ID = keyboard.next();
               System.out.println("here's the ID you entered" + ID);
               break;
           case 2:

               for (GradeBookTracker tc : card)
               {
                   if (tc.ID.equals(ID))
                   {
                       assignmentsArray = tc.assignmentsArray;
                   }
               }    
               System.out.println("Enter assignment you are changing.");
               assignmentToChange = keyboard.nextInt();
               System.out.println("Enter the new assignment");
               newAssignment = keyboard.nextInt();

               for (int i = 0; i < assignmentsArray.length; i++)
               {
                   if(assignmentsArray[i] == assignmentToChange)
                   {
                       assignmentsArray[i] = newAssignment;
                   }
               }    break;
           case 3:

               for (GradeBookTracker tc : card)
               {
                   if (tc.ID.equals(ID))
                   {
                       discussionsArray = tc.discussionsArray;
                   }
               }    
               System.out.println("Enter discussion you are changing.");
               discussionToChange = keyboard.nextInt();
               System.out.println("Enter the discussion");
               newDiscussion = keyboard.nextInt();

               for (int i = 0; i < discussionsArray.length; i++)
               {
                   if(discussionsArray[i] == discussionToChange)
                   {
                       discussionsArray[i] = newDiscussion;
                   }
               }    break;

           case 4:

               for (GradeBookTracker tc : card)
               {
                   if (tc.ID.equals(ID))
                   {
                       examsArray = tc.examsArray;
                   }
               }    
               System.out.println("Enter exam you are changing.");
               assignmentToChange = keyboard.nextInt();
               System.out.println("Enter the new exam");
               newExam = keyboard.nextInt();

               for (int i = 0; i < examsArray.length; i++)
               {
                   if(examsArray[i] == examToChange)
                   {
                       examsArray[i] = newExam;
                   }
               }    break;
           default:
               System.out.println("Invalid Choice");
               return;
           case 5:
               System.out.println("ENTER THE NEW INDIVIDUAL PROJECT:\n");
               newIndividual = keyboard.nextInt();
               System.out.println("here's the score you entered " + newIndividual);
               break;
              
        }

    }

}

