//Serena Bailey ITDEV 110 FINAL EXAM
package bailey_finalexam;

import java.util.ArrayList;
import javax.sound.sampled.LineUnavailableException;

public class Controller {
    //Variables
    int option;
    String name;
    String ID;
    int letterGrade;
  
    //this is where we have our stored people to play around with with the application.
    GradeBookTracker tc1 = new GradeBookTracker("Serena", "Bailey", "0788875", new int []{50,50,50,50,50,50,50,50,50,50}, new int []{10,10,10,10,10,10,10,10,10,10}, new int []{150,150}, 100, 500, 100, 300, 1000);
    GradeBookTracker tc2 = new GradeBookTracker("Brianna", "Bailey", "001023", new int []{50,45,45,48,50,50,50,49,50,50}, new int []{10,8,10,10,9,10,10,10,9,10}, new int []{150,145}, 95, 487, 96, 295, 973);
    GradeBookTracker tc3 = new GradeBookTracker("Joe", "Dirt", "000001", new int []{10,10,10,10,10,10,10,10,10,10}, new int []{0,0,0,0,0,0,0,0,0,0}, new int []{100,100}, 50, 100, 0, 200, 350);
    ArrayList<GradeBookTracker> card = new ArrayList<>(); 
    
    public void missionInitialize() throws LineUnavailableException, InterruptedException
    {
        //where the intro is being called and where we have the stored people. we also will begin the program here.
        Admin admin = new Admin();
        admin.intro(); 
        
        card.add(tc1);
        card.add(tc2);
        card.add(tc3);
        
        missionServeMenu();
        admin.exit();  
    }
    public void missionServeMenu() throws InterruptedException, LineUnavailableException
    { 
        //where we are calling to each of the options to determine the users next move.
        Model mod = new Model();
        UserInterface ui = new UserInterface();
        
        do {
            option = ui.getUserInput();
            
            switch(option)
            {
               case 0:
                   System.out.println("You chose to exit. ");
                   break;
               case 1 :
                  ui.getUserInputForAdd(card);  
                  break;
               case 2 :
                  option = ui.getUserInputForSearch();  
                  if (option == 1)
                   {   
                       System.out.println("User selected name search");
                       name = ui.getName();
                       System.out.println("Searching for: " + name);
                       mod.searchByLastName(card, name);
                   }
                   else 
                   {
                       System.out.println("User selected ID search");
                       ID = ui.getID();
                       System.out.println("Searching for: " + ID);
                       mod.searchByID(card, ID);
                   }
                  break; 
               case 3 :
                   mod.displayAll(card);       
                   break;
               case 4 :
                   name = ui.getNameToEdit();
                   ui.getUserInputForEdit(card, name);               
                   break;
                case 5:
                   letterGrade = ui.getLetterGrade();
                   ui.letterGrade();
                   break;
               default : 
                   System.out.println("Invalid Option!  Please try again");    
            }
          
        } while (option != 0);
    }
}
